<template>
  <creation-step
    :previous-step="{
      name: 'campus-campus_id-shuttles-book',
      params: { campus_id: campus.id }
    }"
    @submit="submit"
  >
    <template #form>
      <fieldset class="fields-box">
        <h2>Départ</h2>
        <div>
          <ec-field
            label="Arrêt"
            field-id="departureStop"
          >
            <input
              id="departureStop"
              :value="departure.label"
              disabled
              class="input"
            >
          </ec-field>
          <ec-field
            label="Horaire"
            field-id="departureDate"
          >
            <input
              id="departureDate"
              :value="ISODateToLocaleString(departure.time, FULL_DATE)"
              disabled
              class="input"
            >
          </ec-field>
        </div>
        <h2>Arrivée</h2>
        <div>
          <ec-field
            label="Arrêt"
            field-id="departureStop"
          >
            <input
              id="arrivalStop"
              :value="arrival.label"
              disabled
              class="input"
            >
          </ec-field>
          <ec-field
            label="Horaire"
            field-id="arrivalDate"
          >
            <input
              id="arrivalDate"
              :value="ISODateToLocaleString(arrival.time, FULL_DATE)"
              disabled
              class="input"
            >
          </ec-field>
        </div>
      </fieldset>
      <form-button>
        Lancer la réservation
      </form-button>
    </template>
  </creation-step>
</template>

<script>
import { DateTime } from 'luxon';
import creationStep from '~/components/creation-step/generic.vue';
import formButton from '~/components/creation-step/form-button.vue';
import errorsManagement from '~/helpers/mixins/errors-management';
import { generateTitles } from '~/store/context';
import init from '~/components/creation-step/mixins/init-component';

const TITLE = 'Confirmez vos informations pour lancer la demande de réservation';
const SUBTITLE = 'Une fois la demande faite, vous recevrez un SMS ou un e-mail de confirmation.';

export default {
  components: {
    formButton,
    creationStep,
  },
  mixins: [
    init(generateTitles(TITLE, SUBTITLE)),
    errorsManagement(),
  ],
  props: {
    campus: {
      type: Object,
      default: () => ({}),
    },
  },
  async asyncData({ $api, params, query }) {
    const { data: shuttle } = await $api.query('shuttles')
      .setMask('id,passengers,shuttleFactory')
      .setCampus(params.campus)
      .get(query.shuttle);
    const departure = shuttle.shuttleFactory.stops.find((stop) => stop.id === query.departure);
    const arrival = shuttle.shuttleFactory.stops.find((stop) => stop.id === query.arrival);
    return {
      id: shuttle.id,
      passengers: shuttle.passengers,
      departure,
      arrival,
    };
  },
  computed: {
    FULL_DATE() {
      return {
        weekday: 'short', month: 'short', day: '2-digit', hour: '2-digit', minute: '2-digit',
      };
    },
  },
  methods: {
    ISODateToLocaleString(date, format = {}) {
      return DateTime.fromISO(date).toLocaleString(format);
    },
    async submit() {
      const { data: user } = await
      this.$api.query('jwt').setMask('id,email,firstname,lastname,phone(original)').user();
      const payload = {
        passengers: [
          ...this.passengers,
          {
            ...user,
            phone: user.phone.original,
            departure: this.departure,
            arrival: this.arrival,
          },
        ],
      };
      this.handleCommonErrorsBehavior(async () => {
        await this.$api.query('shuttles').setCampus(this.campus.id).edit(this.id, payload);
        this.$toast.success('Place réservée avec succès');
        this.$router.push({ name: 'my-account-current-rides' });
      });
    },
  },
};
</script>

<style lang="scss" scoped>
  .form {
    h2 {
      margin: 0 .5em;
      font-weight: 700;
      text-transform: uppercase;
    }
    fieldset > div  {
      display: grid;
      grid-template-columns: repeat(2, 1fr);
      margin-bottom: 1em;
    }

    @media screen and (max-width: 600px) {
      fieldset, fieldset div {
        display: flex;
        flex-direction: column;
        align-items: center;
        div, .field {
          width: 100%;
        }
      }
    }
  }
</style>
